import sys
import os
modules_path = '../../../modules/'
if os.path.exists(modules_path):
    sys.path.insert(1, modules_path)

from db.entities import Location, PopularLocation, UserCluster
from typing import List, Dict, Tuple
from db.repository import Repository
from processing.clusterer import Clusterer


DEBUG = False

# used to cluster the users based on their main location
user_clusterer = Clusterer()

repo = Repository()


def run_location_clustering():
    all_location_traces = repo.get_locations()

    cluster_result = user_clusterer.run(
        [l.to_serializable_dict() for l in all_location_traces])

    clusters = [UserCluster(key, value)
                for key, value in cluster_result.items()]

    store_user_clusters(clusters)


def store_user_clusters(user_clusters: List[UserCluster]):
    if DEBUG:
        print(user_clusters)
        return

    for c in user_clusters:
        repo.add_user_cluster(c)


if __name__ == "__main__":
    run_location_clustering()
